:Begin:
:Function: mA0
:Pattern: A0[m_, opt___Rule]
:Arguments: {N[m], N[Delta /. {opt} /. Options[A0]],
   N[Mudim /. {opt} /. Options[A0]]}
:ArgumentTypes: {Real, Real, Real}
:ReturnType: Manual
:End:

:Evaluate: Options[A0] = {Delta -> 0, Mudim -> 1}


#include "mathlink.h"
#include <math.h>


static void mA0(const double m,
    const double delta, const double mudim) {
  double a0_r = (m == 0) ? 0 : m*(1 - log(m/mudim) + delta);
  MLPutFunction(stdlink, "Complex", 2);
  MLPutReal(stdlink, a0_r);
  MLPutReal(stdlink, 0.);
  MLEndPacket(stdlink);
}


int main(int argc, char **argv) {
  return MLMain(argc, argv);
}

